<script lang="ts">
    import getHumanName from '$utils/getHumanName'
    import type Unit from '$models/Unit'
    import { createEventDispatcher } from 'svelte'

    export let unit: Unit

    let value = 0

    const dispatch = createEventDispatcher()
    const append = async () => {
        dispatch('select', value)
    }
</script>

<div>
    <details>
        <summary>{getHumanName(unit.type)}</summary>
        <ul>
            <li>Attack: {unit.attack}</li>
            <li>Defense: {unit.defense}</li>
            <li>Speed: {unit.speed}</li>
        </ul>
    </details>
    <div class="control">
        <label for="{unit.type}-build-amount">Number to select</label>
        <div class="inputs">
            {#if unit.quantity > 0}
                <input
                    id="{unit.type}-build-amount"
                    type="number"
                    min="0"
                    max={unit.quantity}
                    step="1"
                    bind:value
                    on:change={append}
                />
            {:else}
                <p>any</p>
            {/if}
        </div>
    </div>
</div>

<style lang="postcss">
    summary {
        @apply font-semibold;
    }

    ul {
        @apply px-4 text-trueGray-500 dark:text-trueGray-400;
    }

    .control {
        @apply flex items-center justify-between w-full;

        label {
            @apply whitespace-nowrap w-full;
        }

        .inputs {
            @apply flex-none flex gap-x-2 max-w-[50%];

            input[type='number'] {
                @apply flex-shrink px-2 py-1 min-w-0 text-trueGray-900;
            }

            input[type='submit'] {
                @apply px-4 py-1 cursor-pointer transition-colors duration-150 ease-out
                bg-fuchsia-200 text-fuchsia-900 hover:bg-fuchsia-100 hover:text-fuchsia-800
                dark:bg-fuchsia-900 dark:text-fuchsia-50 hover:dark:bg-fuchsia-800 hover:dark:text-fuchsia-100;
                clip-path: polygon(calc(100% - 0.1rem) 0, 100% 100%, 0.1rem 100%, 0 0);

                &:disabled {
                    @apply bg-gray-200 cursor-default
                    dark:bg-gray-700;
                }
            }
        }
    }
</style>
